/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./renderer.tsx":
/*!**********************!*\
  !*** ./renderer.tsx ***!
  \**********************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const react_1 = __importDefault(__webpack_require__(/*! react */ "react"));
const extensions_1 = __webpack_require__(/*! @k8slens/extensions */ "@k8slens/extensions");
const namespace_menu_item_1 = __webpack_require__(/*! ./src/namespace-menu-item */ "./src/namespace-menu-item.tsx");
const node_menu_item_1 = __webpack_require__(/*! ./src/node-menu-item */ "./src/node-menu-item.tsx");
const pod_menu_item_1 = __webpack_require__(/*! ./src/pod-menu-item */ "./src/pod-menu-item.tsx");
const service_menu_item_1 = __webpack_require__(/*! ./src/service-menu-item */ "./src/service-menu-item.tsx");
const kubeshark_preference_store_1 = __webpack_require__(/*! ./src/kubeshark-preference-store */ "./src/kubeshark-preference-store.ts");
const kubeshark_preference_1 = __webpack_require__(/*! ./src/kubeshark-preference */ "./src/kubeshark-preference.tsx");
/**
 *
 * RendererExtension which extends LensRendererExtension runs in Lens' 'renderer' process (NOT 'main' process)
 * main vs renderer <https://www.electronjs.org/docs/tutorial/quick-start#main-and-renderer-processes>
 *
 * LensRendererExtension is the interface to Lens' renderer process. Its api allows you to access, configure,
 * and customize Lens data add custom Lens UI elements, and generally run custom code in Lens' renderer process.
 *
 * To see console statements in 'renderer' process, go to the console tab in DevTools in Lens
 * View > Toggle Developer Tools > Console.
 *
 */
class KubesharkRenderer extends extensions_1.Renderer.LensExtension {
    constructor() {
        super(...arguments);
        this.kubeObjectMenuItems = [
            {
                kind: "Namespace",
                apiVersions: ["v1"],
                components: {
                    MenuItem: (props) => (react_1.default.createElement(namespace_menu_item_1.NamespaceMenuItem, Object.assign({}, props))),
                },
            },
            {
                kind: "Node",
                apiVersions: ["v1"],
                components: {
                    MenuItem: (props) => (react_1.default.createElement(node_menu_item_1.NodeMenuItem, Object.assign({}, props))),
                },
            },
            {
                kind: "Pod",
                apiVersions: ["v1"],
                components: {
                    MenuItem: (props) => (react_1.default.createElement(pod_menu_item_1.PodMenuItem, Object.assign({}, props))),
                },
            },
            {
                kind: "Service",
                apiVersions: ["v1"],
                components: {
                    MenuItem: (props) => (react_1.default.createElement(service_menu_item_1.ServiceMenuItem, Object.assign({}, props))),
                },
            },
        ];
        this.appPreferences = [
            {
                title: "Kubeshark Preferences",
                components: {
                    Hint: () => react_1.default.createElement(kubeshark_preference_1.KubesharkPreferenceHint, null),
                    Input: () => react_1.default.createElement(kubeshark_preference_1.KubesharkPreferenceInput, null)
                }
            }
        ];
    }
    /**
     * onActivate is called when your extension has been successfully enabled.
     */
    async onActivate() {
        kubeshark_preference_store_1.kubesharkPreferenceStore.loadExtension(this);
        console.log("activated");
    }
}
exports["default"] = KubesharkRenderer;


/***/ }),

/***/ "./src/kubeshark-preference-store.ts":
/*!*******************************************!*\
  !*** ./src/kubeshark-preference-store.ts ***!
  \*******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.kubesharkPreferenceStore = exports.KubesharkPreferenceStore = void 0;
const extensions_1 = __webpack_require__(/*! @k8slens/extensions */ "@k8slens/extensions");
const mobx_1 = __webpack_require__(/*! mobx */ "mobx");
class KubesharkPreferenceStore extends extensions_1.Common.Store.ExtensionStore {
    constructor() {
        super({
            configName: "kubeshark-preference-store",
            defaults: {
                url: "https://localhost:8899/"
            }
        });
        this.url = "https://localhost:8899/";
        (0, mobx_1.makeObservable)(this);
    }
    fromStore(data) {
        this.url = data.url;
    }
    toJSON() {
        const value = {
            url: this.url,
        };
        return (0, mobx_1.toJS)(value);
    }
}
__decorate([
    mobx_1.observable
], KubesharkPreferenceStore.prototype, "url", void 0);
exports.KubesharkPreferenceStore = KubesharkPreferenceStore;
exports.kubesharkPreferenceStore = new KubesharkPreferenceStore();


/***/ }),

/***/ "./src/kubeshark-preference.tsx":
/*!**************************************!*\
  !*** ./src/kubeshark-preference.tsx ***!
  \**************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KubesharkPreferenceHint = exports.KubesharkPreferenceInput = void 0;
const extensions_1 = __webpack_require__(/*! @k8slens/extensions */ "@k8slens/extensions");
const mobx_react_1 = __webpack_require__(/*! mobx-react */ "mobx-react");
const react_1 = __importDefault(__webpack_require__(/*! react */ "react"));
const kubeshark_preference_store_1 = __webpack_require__(/*! ./kubeshark-preference-store */ "./src/kubeshark-preference-store.ts");
let KubesharkPreferenceInput = class KubesharkPreferenceInput extends react_1.default.Component {
    render() {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(extensions_1.Renderer.Component.Input, { value: kubeshark_preference_store_1.kubesharkPreferenceStore.url, theme: "round-black", placeholder: "Enter Kubeshark's URL. It can be this one => http://localhost:8899/", onChange: v => { kubeshark_preference_store_1.kubesharkPreferenceStore.url = v; } })));
    }
};
KubesharkPreferenceInput = __decorate([
    mobx_react_1.observer
], KubesharkPreferenceInput);
exports.KubesharkPreferenceInput = KubesharkPreferenceInput;
class KubesharkPreferenceHint extends react_1.default.Component {
    render() {
        return (react_1.default.createElement("span", null));
    }
}
exports.KubesharkPreferenceHint = KubesharkPreferenceHint;


/***/ }),

/***/ "./src/namespace-menu-item.tsx":
/*!*************************************!*\
  !*** ./src/namespace-menu-item.tsx ***!
  \*************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.NamespaceMenuItem = void 0;
const react_1 = __importDefault(__webpack_require__(/*! react */ "react"));
const extensions_1 = __webpack_require__(/*! @k8slens/extensions */ "@k8slens/extensions");
const kubeshark_preference_store_1 = __webpack_require__(/*! ./kubeshark-preference-store */ "./src/kubeshark-preference-store.ts");
const { Component: { MenuItem, Icon }, } = extensions_1.Renderer;
function NamespaceMenuItem(props) {
    const { object: namespace, toolbar } = props;
    if (!namespace)
        return null;
    const namespaceName = namespace.getName();
    const openKubeshark = () => {
        extensions_1.Common.Util.openExternal(kubeshark_preference_store_1.kubesharkPreferenceStore.url + `?q=src.namespace=="${namespaceName}" or dst.namespace=="${namespaceName}"`);
    };
    return (react_1.default.createElement(MenuItem, { onClick: openKubeshark },
        react_1.default.createElement(Icon, { material: "speaker_group", interactive: toolbar, title: "Show Traffic Using Kubeshark" }),
        react_1.default.createElement("span", { className: "title" },
            "Show traffic for ",
            namespaceName)));
}
exports.NamespaceMenuItem = NamespaceMenuItem;


/***/ }),

/***/ "./src/node-menu-item.tsx":
/*!********************************!*\
  !*** ./src/node-menu-item.tsx ***!
  \********************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.NodeMenuItem = void 0;
const react_1 = __importDefault(__webpack_require__(/*! react */ "react"));
const extensions_1 = __webpack_require__(/*! @k8slens/extensions */ "@k8slens/extensions");
const kubeshark_preference_store_1 = __webpack_require__(/*! ./kubeshark-preference-store */ "./src/kubeshark-preference-store.ts");
const { Component: { MenuItem, Icon }, } = extensions_1.Renderer;
function NodeMenuItem(props) {
    const { object: node, toolbar } = props;
    if (!node)
        return null;
    const nodeName = node.getName();
    const openKubeshark = () => {
        extensions_1.Common.Util.openExternal(kubeshark_preference_store_1.kubesharkPreferenceStore.url + `?q=node.name=="${nodeName}"`);
    };
    return (react_1.default.createElement(MenuItem, { onClick: openKubeshark },
        react_1.default.createElement(Icon, { material: "speaker_group", interactive: toolbar, title: "Show Traffic Using Kubeshark" }),
        react_1.default.createElement("span", { className: "title" },
            "Show traffic for ",
            nodeName)));
}
exports.NodeMenuItem = NodeMenuItem;


/***/ }),

/***/ "./src/pod-menu-item.tsx":
/*!*******************************!*\
  !*** ./src/pod-menu-item.tsx ***!
  \*******************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.PodMenuItem = void 0;
const react_1 = __importDefault(__webpack_require__(/*! react */ "react"));
const extensions_1 = __webpack_require__(/*! @k8slens/extensions */ "@k8slens/extensions");
const kubeshark_preference_store_1 = __webpack_require__(/*! ./kubeshark-preference-store */ "./src/kubeshark-preference-store.ts");
const { Component: { MenuItem, Icon }, } = extensions_1.Renderer;
function PodMenuItem(props) {
    const { object: pod, toolbar } = props;
    if (!pod)
        return null;
    const podName = pod.getName();
    const openKubeshark = () => {
        extensions_1.Common.Util.openExternal(kubeshark_preference_store_1.kubesharkPreferenceStore.url + `?q=src.name=="${podName}" or dst.name=="${podName}"`);
    };
    return (react_1.default.createElement(MenuItem, { onClick: openKubeshark },
        react_1.default.createElement(Icon, { material: "speaker_group", interactive: toolbar, title: "Show Traffic Using Kubeshark" }),
        react_1.default.createElement("span", { className: "title" },
            "Show traffic for ",
            podName)));
}
exports.PodMenuItem = PodMenuItem;


/***/ }),

/***/ "./src/service-menu-item.tsx":
/*!***********************************!*\
  !*** ./src/service-menu-item.tsx ***!
  \***********************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ServiceMenuItem = void 0;
const react_1 = __importDefault(__webpack_require__(/*! react */ "react"));
const extensions_1 = __webpack_require__(/*! @k8slens/extensions */ "@k8slens/extensions");
const kubeshark_preference_store_1 = __webpack_require__(/*! ./kubeshark-preference-store */ "./src/kubeshark-preference-store.ts");
const { Component: { MenuItem, Icon }, } = extensions_1.Renderer;
function ServiceMenuItem(props) {
    const { object: service, toolbar } = props;
    if (!service)
        return null;
    const serviceName = service.getName();
    const openKubeshark = () => {
        extensions_1.Common.Util.openExternal(kubeshark_preference_store_1.kubesharkPreferenceStore.url + `?q=src.name=="${serviceName}" or dst.name=="${serviceName}"`);
    };
    return (react_1.default.createElement(MenuItem, { onClick: openKubeshark },
        react_1.default.createElement(Icon, { material: "speaker_group", interactive: toolbar, title: "Show Traffic Using Kubeshark" }),
        react_1.default.createElement("span", { className: "title" },
            "Show traffic for ",
            serviceName)));
}
exports.ServiceMenuItem = ServiceMenuItem;


/***/ }),

/***/ "@k8slens/extensions":
/*!****************************************!*\
  !*** external "global.LensExtensions" ***!
  \****************************************/
/***/ ((module) => {

module.exports = global.LensExtensions;

/***/ }),

/***/ "mobx":
/*!******************************!*\
  !*** external "global.Mobx" ***!
  \******************************/
/***/ ((module) => {

module.exports = global.Mobx;

/***/ }),

/***/ "mobx-react":
/*!***********************************!*\
  !*** external "global.MobxReact" ***!
  \***********************************/
/***/ ((module) => {

module.exports = global.MobxReact;

/***/ }),

/***/ "react":
/*!*******************************!*\
  !*** external "global.React" ***!
  \*******************************/
/***/ ((module) => {

module.exports = global.React;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./renderer.tsx");
/******/ 	module.exports = __webpack_exports__;
/******/ 	
/******/ })()
;
//# sourceMappingURL=renderer.js.map